package test.mdb;

import java.util.HashMap;
import java.util.Map;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;

import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.core.client.ClientSessionFactory;
import org.hornetq.api.jms.HornetQJMSClient;
import org.hornetq.api.jms.JMSFactoryType;
import org.hornetq.core.client.impl.ClientSessionFactoryImpl;
import org.hornetq.core.remoting.impl.invm.InVMConnectorFactory;
import org.hornetq.core.remoting.impl.netty.NettyConnectorFactory;
import org.hornetq.jms.client.HornetQConnectionFactory;

public class PublishMessage {
	public static void main(String[] args) throws Exception {
		for (int i = 0; i < 4000; i++) {
			try {
				Thread.sleep(1000);
				Connection connection = null;
				try {
					// Step 1. Directly instantiate the JMS Queue object.
					Topic topic = HornetQJMSClient
							.createTopic("ndipiazza.pl.testing");

					// Step 2. Instantiate the TransportConfiguration object which
					// contains the knowledge of what transport to use,
					// The server port etc.

					Map<String, Object> connectionParams = new HashMap<String, Object>();
					connectionParams.put("port", 5445);
					connectionParams.put("host", "localhost");

					TransportConfiguration transportConfiguration = new TransportConfiguration(
							NettyConnectorFactory.class.getName(), connectionParams);

					// Step 3 Directly instantiate the JMS ConnectionFactory object
					// using that TransportConfiguration
					HornetQConnectionFactory cf = new HornetQConnectionFactory(
							false, transportConfiguration);

					// Step 4.Create a JMS Connection
					connection = cf.createConnection();

					// Step 5. Create a JMS Session
					Session session = connection.createSession(false,
							Session.AUTO_ACKNOWLEDGE);

					// Step 6. Create a JMS Message Producer
					MessageProducer producer = session.createProducer(topic);

					// Step 7. Create a Text Message
					TextMessage message = session
							.createTextMessage("This is a text message");

					System.out.println("Sent message: " + message.getText());

					// Step 8. Send the Message
					producer.send(message);

					producer.close();

					connection.close();
				} finally {
					if (connection != null) {
						connection.close();
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
